import type { _CNContact } from "./CNContact.js";
import type { _NSArray } from "../Foundation/NSArray.js";
import type { _NSData } from "../Foundation/NSData.js";
import type { _NSDateComponents } from "../Foundation/NSDateComponents.js";
import type { _NSString } from "../Foundation/NSString.js";
import type { CNContactType } from "./CNContactType.js";
export declare class _CNMutableContact extends _CNContact {
    static alloc(): _CNMutableContact;
    static new(): _CNMutableContact;
    init(): _CNMutableContact;
    contactType(): CNContactType;
    setContactType$(value: CNContactType): void;
    namePrefix(): _NSString;
    setNamePrefix$(value: _NSString): void;
    givenName(): _NSString;
    setGivenName$(value: _NSString): void;
    middleName(): _NSString;
    setMiddleName$(value: _NSString): void;
    familyName(): _NSString;
    setFamilyName$(value: _NSString): void;
    previousFamilyName(): _NSString;
    setPreviousFamilyName$(value: _NSString): void;
    nameSuffix(): _NSString;
    setNameSuffix$(value: _NSString): void;
    nickname(): _NSString;
    setNickname$(value: _NSString): void;
    organizationName(): _NSString;
    setOrganizationName$(value: _NSString): void;
    departmentName(): _NSString;
    setDepartmentName$(value: _NSString): void;
    jobTitle(): _NSString;
    setJobTitle$(value: _NSString): void;
    phoneticGivenName(): _NSString;
    setPhoneticGivenName$(value: _NSString): void;
    phoneticMiddleName(): _NSString;
    setPhoneticMiddleName$(value: _NSString): void;
    phoneticFamilyName(): _NSString;
    setPhoneticFamilyName$(value: _NSString): void;
    phoneticOrganizationName(): _NSString;
    setPhoneticOrganizationName$(value: _NSString): void;
    note(): _NSString;
    setNote$(value: _NSString): void;
    imageData(): _NSData | null;
    setImageData$(value: _NSData | null): void;
    phoneNumbers(): _NSArray;
    setPhoneNumbers$(value: _NSArray): void;
    emailAddresses(): _NSArray;
    setEmailAddresses$(value: _NSArray): void;
    postalAddresses(): _NSArray;
    setPostalAddresses$(value: _NSArray): void;
    urlAddresses(): _NSArray;
    setUrlAddresses$(value: _NSArray): void;
    contactRelations(): _NSArray;
    setContactRelations$(value: _NSArray): void;
    socialProfiles(): _NSArray;
    setSocialProfiles$(value: _NSArray): void;
    instantMessageAddresses(): _NSArray;
    setInstantMessageAddresses$(value: _NSArray): void;
    /**
     * @abstract The Gregorian birthday. @description Only uses day, month and year components. Needs to have at least a day and a month.
     */
    birthday(): _NSDateComponents | null;
    setBirthday$(value: _NSDateComponents | null): void;
    /**
     * @abstract The alternate birthday (Lunisolar). @description Only uses day, month, year and calendar components. Needs to have at least a day and a month. Calendar must be Chinese, Hebrew or Islamic.
     */
    nonGregorianBirthday(): _NSDateComponents | null;
    setNonGregorianBirthday$(value: _NSDateComponents | null): void;
    /**
     * @abstract Other Gregorian dates (anniversaries, etc). @description Only uses day, month and year components. Needs to have at least a day and a month.
     */
    dates(): _NSArray;
    setDates$(value: _NSArray): void;
}
